package com.haircut.pranks.app.uiview;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.bumptech.glide.Glide;
import com.haircut.pranks.app.R;
import com.haircut.pranks.app.data.ChildData;
import com.haircut.pranks.app.databinding.ActivityPlayBinding;
import com.haircut.pranks.app.listener.ListenerSounds;
import com.haircut.pranks.app.listener.ListenerTimer;
import com.haircut.pranks.app.manager.DataManager;
import com.haircut.pranks.app.manager.RecyclerSpace;
import com.haircut.pranks.app.manager.Tools;
import com.haircut.pranks.app.popupwindows.PopupCountdown;
import com.haircut.pranks.app.recyadapter.AdapterChild;

import java.io.IOException;
import java.util.List;

public class ActPlaySounds extends AppCompatActivity implements View.OnClickListener, ListenerTimer, ListenerSounds {

    private ActivityPlayBinding playBinding;

    private ChildData childData;
    private PopupCountdown popupCountdown;

    private MediaPlayer mediaPlayer;
    private BroadcastReceiver volumeReceiver;
    private CountDownTimer countDownTimer;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        playBinding = ActivityPlayBinding.inflate(getLayoutInflater());
        setContentView(playBinding.getRoot());
        Tools.setStatusBarTextColor(this, true);
        childData = (ChildData) getIntent().getSerializableExtra(Tools.KEY_PLAY_DATA);

        initAudio();
        String covert = childData.getCovert();
        if (covert != null && !covert.isEmpty()) {
            Glide.with(this).load(covert)
                    .placeholder(R.drawable.im_import_audio)
                    .into(playBinding.image);
        } else {
            Glide.with(this).load(R.drawable.im_import_audio)
                    .into(playBinding.image);
        }
        playBinding.name.setText(childData.getName());
        playBinding.back.setOnClickListener(this);
        playBinding.linearPlay.setOnClickListener(this);
        playBinding.imLike.setOnClickListener(this);
        playBinding.imLoop.setOnClickListener(this);
        playBinding.imTimer.setOnClickListener(this);

        Tools.setVolume(this, playBinding.seekbar);

        initLike();
        loadMore();
        volumeReceiver();

    }

    private void stopCountDown() {
        Log.d("------", "------stopCountDown");
        if (countDownTimer != null) {
            countDownTimer.cancel();
        }
    }

    private void startCountDown(long time) {
        stopCountDown();
        countDownTimer = new CountDownTimer(time, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {

            }

            @Override
            public void onFinish() {
                popupCountdown.setOffSelected();
                if (!mediaPlayer.isPlaying()) {
                    playBinding.btnPlay.setSelected(true);
                    mediaPlayer.start();
                }
            }
        };
        countDownTimer.start();
    }

    private void volumeReceiver() {
        volumeReceiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                if (intent.getAction().equals("android.media.VOLUME_CHANGED_ACTION")) {
                    AudioManager audioManager = (AudioManager) context.getSystemService(Context.AUDIO_SERVICE);
                    int currentVolume = audioManager.getStreamVolume(AudioManager.STREAM_MUSIC);
                    if (playBinding.seekbar.getProgress() != currentVolume) {
                        playBinding.seekbar.setProgress(currentVolume);
                    }

                }
            }
        };
        IntentFilter filter = new IntentFilter("android.media.VOLUME_CHANGED_ACTION");
        registerReceiver(volumeReceiver, filter);
    }

    private void initLike() {
        boolean b = DataManager.checkLike(childData);
        playBinding.imLike.setSelected(b);


    }

    private void loadMore() {
        List<ChildData> more = DataManager.getMore();
        RecyclerSpace itemHelper = new RecyclerSpace(0, 0, (int) Tools.dpToPx(3));
        AdapterChild favoriteAdapter = new AdapterChild(this, more, 1, this);
        playBinding.moreRecycler.setLayoutManager(new LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false));
        playBinding.moreRecycler.setAdapter(favoriteAdapter);
        playBinding.moreRecycler.addItemDecoration(itemHelper);
    }

    private void initAudio() {
        showPlayBtn(false);
        mediaPlayer = new MediaPlayer();
        try {
            mediaPlayer.reset();
            mediaPlayer.setDataSource(childData.getAudioUrl());
            mediaPlayer.prepareAsync();
            mediaPlayer.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                @Override
                public void onPrepared(MediaPlayer mp) {
                    showPlayBtn(true);
                }
            });

            mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                @Override
                public void onCompletion(MediaPlayer mp) {
                    playBinding.btnPlay.setSelected(false);
                }
            });
        } catch (IOException ioException) {
            showPlayBtn(true);
            Toast.makeText(this, "----------prepare fail", Toast.LENGTH_SHORT).show();
        }
    }

    private void showPlayBtn(boolean showBtn) {
        if (showBtn) {
            playBinding.linearPlay.setVisibility(View.VISIBLE);
            playBinding.playLoading.setVisibility(View.GONE);
        } else {
            playBinding.linearPlay.setVisibility(View.GONE);
            playBinding.playLoading.setVisibility(View.VISIBLE);
        }

    }


    @Override
    public void onClick(View v) {
        if (v.equals(playBinding.back)) {
            finish();
        } else if (v.equals(playBinding.linearPlay)) {
            boolean selected = playBinding.btnPlay.isSelected();
            if (selected) {
                if (mediaPlayer.isPlaying()) {
                    mediaPlayer.pause();
                }
            } else {
                if (!mediaPlayer.isPlaying()) {
                    mediaPlayer.start();
                }
            }
            playBinding.btnPlay.setSelected(!selected);

        } else if (v.equals(playBinding.imLike)) {
            playBinding.imLike.setSelected(!playBinding.imLike.isSelected());
            boolean selected = playBinding.imLike.isSelected();
            if (selected) {
                DataManager.addLike(childData);
            } else {
                DataManager.removeLike(childData);
            }
        } else if (v.equals(playBinding.imLoop)) {
            playBinding.imLoop.setSelected(!playBinding.imLoop.isSelected());
            mediaPlayer.setLooping(playBinding.imLoop.isSelected());
        } else if (v.equals(playBinding.imTimer)) {
            if (popupCountdown == null) {
                popupCountdown = new PopupCountdown(ActPlaySounds.this, this);
            }
            popupCountdown.showTop(playBinding.imTimer);
        }

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mediaPlayer.isPlaying()) {
            mediaPlayer.stop();
        }
        mediaPlayer.release();
        mediaPlayer = null;
        stopCountDown();
    }

    @Override
    public void onClickTimerListener(long time) {
        popupCountdown.hide();
        if (time == -1) {
            stopCountDown();
        } else {
            startCountDown(time);
        }

    }

    @Override
    public void onClickSoundsListener(ChildData data) {
        Intent intent = new Intent(this, ActPlaySounds.class);
        intent.putExtra(Tools.KEY_PLAY_DATA, data);
        startActivity(intent);
        finish();
    }
}